﻿using System;
using System.ComponentModel;
using Wisej.Web;

namespace TextBoxValidation
{
    public partial class Window2 : Form
    {
        public Window2()
        {
            InitializeComponent();
            this.btnLoad.Click += btnLoad_Click;
            this.dgv.CellValidating += dgv_CellValidating;
        }

        protected override void OnLoad(EventArgs e)
        {
            base.OnLoad(e);

            this.dgv.AutoGenerateColumns = false;
            this.dgv.AutoSizeColumnsMode = DataGridViewAutoSizeColumnsMode.Fill;
            this.dgv.RowHeadersVisible = true;
            this.dgv.RowHeadersWidth = 25;
            this.dgv.ColumnHeadersHeight = 30;
            this.dgv.ColumnHeadersDefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter;
            this.dgv.ColumnHeadersHeightSizeMode = DataGridViewColumnHeadersHeightSizeMode.EnableResizing;
            this.dgv.RowTemplate.Height = this.dgv.ColumnHeadersHeight;
            //this.dgv.SelectionMode = DataGridViewSelectionMode.FullRowSelect;
            this.dgv.SelectionMode = DataGridViewSelectionMode.CellSelect;
            this.dgv.AllowUserToDeleteRows = true;
            this.dgv.AllowUserToAddRows = true;
            this.dgv.AllowUserToResizeColumns = true;
            this.dgv.ReadOnly = false;
            this.dgv.VirtualMode = true;

            DataGridViewTextBoxColumn CustomerID = new DataGridViewTextBoxColumn();
            CustomerID.Name = "CustomerID";
            CustomerID.HeaderText = "Customer ID";
            CustomerID.DataPropertyName = "CustomerID";
            CustomerID.AutoSizeMode = DataGridViewAutoSizeColumnMode.None;
            CustomerID.DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter;
            CustomerID.Width = 75;

            DataGridViewTextBoxColumn CompanyName = new DataGridViewTextBoxColumn();
            CompanyName.Name = "CompanyName";
            CompanyName.HeaderText = "Company Name";
            CompanyName.DataPropertyName = "CompanyName";
            CompanyName.AutoSizeMode = DataGridViewAutoSizeColumnMode.AllCellsExceptHeader;

            DataGridViewTextBoxColumn ContactName = new DataGridViewTextBoxColumn();
            ContactName.Name = "ContactName";
            ContactName.HeaderText = "Contact Name";
            ContactName.DataPropertyName = "ContactName";
            ContactName.MinimumWidth = 150;
            ContactName.DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleRight;


            DataGridViewTextBoxColumn ContactTitle = new DataGridViewTextBoxColumn();
            ContactTitle.Name = "ContactTitle";
            ContactTitle.HeaderText = "Contact Title";
            ContactTitle.DataPropertyName = "ContactTitle";
            ContactTitle.MinimumWidth = 150;


            DataGridViewTextBoxColumn Address = new DataGridViewTextBoxColumn();
            Address.Name = "Address";
            Address.HeaderText = "Address";
            Address.DataPropertyName = "Address";
            Address.MinimumWidth = 100;
            Address.AutoSizeMode = DataGridViewAutoSizeColumnMode.Fill;

            dgv.Columns.AddRange(new DataGridViewTextBoxColumn[] { CustomerID, CompanyName, ContactName, ContactTitle, Address });

            PopulateGrid();
        }

        private void btnLoad_Click(object sender, EventArgs e)
        {
            PopulateGrid();
        }

        private void PopulateGrid()
        {
            dgv.DataSource = null;
            dgv.DataSource = CreateDummyData();
        }


        private void dgv_CellValidating(object sender, DataGridViewCellValidatingEventArgs e)
        {
            if ((e.ColumnIndex == dgv.Columns["CustomerID"].Index) && string.IsNullOrEmpty((string)e.FormattedValue))
            {
                e.Cancel = true;
            }

        }


        private BindingList<Customer> CreateDummyData()
        {
            var customer1 = new Customer
            {
                CustomerID = "CUST1",
                CompanyName = "Company 1",
                ContactName = "Contact 1",
                ContactTitle = "Title 1",
                Address = "Address 1"
            };

            var customer2 = new Customer
            {
                CustomerID = "CUST2",
                CompanyName = "Company 2",
                ContactName = "Contact 2",
                ContactTitle = "Title 2",
                Address = "Address 2"
            };

            var customer3 = new Customer
            {
                CustomerID = "CUST3",
                CompanyName = "Company 3",
                ContactName = "Contact 3",
                ContactTitle = "Title 3",
                Address = "Address 3"
            };

            var customer4 = new Customer
            {
                CustomerID = "CUST4",
                CompanyName = "Company 4",
                ContactName = "Contact 4",
                ContactTitle = "Title 4",
                Address = "Address 4"
            };

            var customer5 = new Customer
            {
                CustomerID = "CUST5",
                CompanyName = "Company 5",
                ContactName = "Contact 5",
                ContactTitle = "Title 5",
                Address = "Address 5"
            };

            var customer6 = new Customer
            {
                CustomerID = "CUST6",
                CompanyName = "Company 6",
                ContactName = "Contact 6",
                ContactTitle = "Title 6",
                Address = "Address 6"
            };

            var customer7 = new Customer
            {
                CustomerID = "CUST7",
                CompanyName = "Company 7",
                ContactName = "Contact 7",
                ContactTitle = "Title 7",
                Address = "Address 7"
            };

            var customer8 = new Customer
            {
                CustomerID = "CUST8",
                CompanyName = "Company 8",
                ContactName = "Contact 8",
                ContactTitle = "Title 8",
                Address = "Address 8"
            };

            var customer9 = new Customer
            {
                CustomerID = "CUST9",
                CompanyName = "Company 9",
                ContactName = "Contact 9",
                ContactTitle = "Title 9",
                Address = "Address 9"
            };

            var customer10 = new Customer
            {
                CustomerID = "CUST10",
                CompanyName = "Company 10",
                ContactName = "Contact 10",
                ContactTitle = "Title 10",
                Address = "Address 10"
            };

            var customers = new BindingList<Customer>
            {
                customer1,
                customer2,
                customer3,
                customer4,
                customer5
                //customer6,
                //customer7,
                //customer8,
                //customer9,
                //customer10,
            };

            return customers;
        }
    }

    public class Customer
    {
        public string CustomerID { get; set; }
        public string CompanyName { get; set; }
        public string ContactName { get; set; }
        public string ContactTitle { get; set; }
        public string Address { get; set; }

    }

}
